local mq = require('mq')

local func = {}

function func.repeatmission()
    local function avoidNil(the_check)
        return the_check or 0
    end
    local function mydelay(del)
        local time = os.time() + del
        while time > os.time() and func.breakdelay == false do
            mq.delay(10)
        end
        func.breakdelay=false
    end
    local function navto(name)
        mq.cmdf('/nav id %s distance=30', mq.TLO.Spawn(name).ID())
        mq.delay(1000)
        while mq.TLO.Navigation.Active() do
            mq.delay(10)
        end
        mq.cmd('/target '..name)
        mq.delay(1000)
    end
    local function navgroupto(name)
        mq.cmdf('/dgga /nav id %s distance=30', mq.TLO.Spawn(name).ID())
        mq.delay(1000)
        while mq.TLO.Navigation.Active() do
            mq.delay(10)
        end
        mq.cmd('/target '..name)
        mq.delay(15000)
    end
    local function groupsayto(who,what)
        mq.delay(math.random(2000,6000))
        mq.cmd('/dgga /target '..who)
        mq.delay(2000)
        mq.cmd('/noparse /bcga //docommand /timed ${Math.Rand[20,80]} /say '..what)
    end
    local function docommands(commands)
        if commands==nil then return false end
        local groupMembers = mq.TLO.Group.Members()
        for k,v in pairs(commands) do
            cmd=tostring(v)
            if string.find(v,'startstuff') then
                docommands(func.toon.startstuff)
            elseif string.find(v,'stopstuff') then  
                docommands(func.toon.stopstuff)
            elseif string.find(v,'doubleinvis') then
                if func.toon.inviscommand~=nil then
                    cont=true
                    while cont do
                        print('doing double invis')
                        func.currentmessage = 'doing double invis'
                        for i,a in pairs(func.toon.inviscommand) do
                            cam=tostring(a)
                            mq.cmd(cam)
                        end
                        cont=false
                        for i = 1, groupMembers do
                            if mq.TLO.Group.Member(i).Present() == true and mq.TLO.Group.Member(i).Spawn.Dead() == false then
                                if mq.TLO.Group.Member(i).Spawn.Invis(1)==false or mq.TLO.Group.Member(i).Spawn.Invis(2)==false then
                                    cont=true
                                    print(mq.TLO.Group.Member(i).Name()..' need invis')
                                end
                            end
                        end
                    end
                end
            elseif string.find(v,'delay') then
                time=cmd:gsub("delay ", "")
                time=time:gsub("/", "")
                time=tonumber(time)
                print('delay '..time)
                func.currentmessage = 'delay '..time
                mydelay(time/1000)
            elseif string.find(v,'/navgroupto') then
                navgroupto(cmd:gsub("/navgroupto ", "")) -- move everyone to mob
            elseif string.find(v,'/navto') then
                navto(cmd:gsub("/navto ", "")) -- move to mob
            elseif string.find(v,'/nav') then
                print(cmd)
                mq.cmd(cmd)
                mq.delay(1000)
                while mq.TLO.Navigation.Active() do
                    mq.delay(100)
                end
            else    
                print(cmd)      
                mq.cmd(cmd)
            end
        end
    end
    if mq.TLO.Task(func.mission).Timer()==nil then
        print('no such mission started, starting')
        if mq.TLO.Zone.ShortName()~=func.startzone then
            func.currentmessage = 'wrong zone, you have to go to '..mq.TLO.Zone(func.startzone).Name()
            mq.delay(2000)
        else
            docommands(func.getmission)
            func.entered=false
        end
    end
    if avoidNil(mq.TLO.Task(func.mission).Timer())>960000 then
        if string.find(mq.TLO.Zone.ShortName(), 'mission') == nil then
            print('wrong zone, need to enter instance')
            if func.enterword~=nil and mq.TLO.Zone.ShortName()==func.startzone then
                navgroupto(func.questgiver)
                mq.delay(2000)
                groupsayto(func.questgiver,func.enterword)
            else
                func.currentmessage = 'wrong zone, you have to go to '..mq.TLO.Zone(func.startzone).Name()
            end
            print('waiting to enter mission zone')
            while string.find(mq.TLO.Zone.ShortName(),  'mission') == nil do
                mq.delay(100)
            end
            func.entered = true
            mq.delay(12000)
            docommands(func.initcommand)
            if func.huntmode == true then
                docommands(func.toon.starthunt)  -- start hunting
            else
                docommands(func.toon.startpull)  -- start pulling
            end
        else
            if string.find(mq.TLO.Zone.ShortName(),  'mission')~=nil then
                func.currentmessage = 'already in the spot. continue killing'
            end
        end
    end
    if avoidNil(mq.TLO.Task(func.mission).Timer())<960000 or (func.mobcount>0 and mq.TLO.SpawnCount()<func.mobcount) or func.endmission==true then
        if func.mobcount>0 and mq.TLO.SpawnCount()<func.mobcount then
            print('not enough mobs to stay here, leaving and starting over')
        else
            if func.endmission==true then
                print('end button pressed, stopping')                
            else
                print('almost out of time, leaving and starting over')
            end
        end
        func.currentmessage = 'killing any mobs currently engaged then ending mission'
        func.entered = false
        docommands(func.toon.stoppull)  -- stop pulling
        mq.delay(200)
        while mq.TLO.Me.XTarget()>0 do --make sure all targets are dead
            mq.delay(20)
        end
        docommands(func.stopcommand)
        func.endmission = false
        mq.delay(120000) -- wait 2 minutes
    end
end

return func