-- prep.lua
-- pezak 2024
--
-- makes use of dannet and a few other plugins. have not reviewed what else to list here yet.
--
-- run and repeat missions (currently only Shei Vinitras and Restless Assault configured)
-- you have to configure toon settings yourself, the default ones is only an example of what can be set.
-- it tries to check that everyone in the group got double invis, as its essential for the missions to be run.
--
-- lua run prep to start
-- lua run prep Shei to quickstart Shei mission
-- lua run prep Restless to quickstart Restless mission
--
-- use at your onw risk, no functionality guaranteed :P
--


local mq = require('mq')
local imgui = require('ImGui')
local openGUI = true
local shouldDrawGUI = true
local config = false
local runmission = require('prep/functions')
local salt = require('prep/salt')
local missioninfo = {}
runmission.initcommand  = {}
runmission.stopcommand  = {}
runmission.endmission   = false
runmission.breakdelay   = false
runmission.entered      = false
local CONFIG_DIR = mq.TLO.MacroQuest.Path() .. "\\lua\\prep\\ini\\"
local SETTINGS_FILE = 'prep_'..mq.TLO.Me.CleanName()..'_'..mq.TLO.Me.Class.ShortName()..'.ini'
local SETTINGS_PATH = CONFIG_DIR..SETTINGS_FILE

mq.delay(1000)
local arg=mq.TLO.Lua.Script('prep').Arguments()

runmission.toon,err = salt.load(SETTINGS_PATH)

if runmission.toon==nil then
    print('creating ini file: '..SETTINGS_PATH..', remember you have to do some settings for this to work, this is just an example/default using rgmercs')
    runmission.toon = { inviscommand = {'/dex <toon name> /timed 1 /alt act 630','/dex <toon name> /alt act 280'},
                        startstuff = {'/bcg <toon name> //rgstart','/bcg <toon name> //rgstart','/bcg <toon name> //heals on'},
                        stopstuff = {'/bcga //end','/bcg <toon name> //heals off'},
                        stoppull = {'/rg dopull 0'},
                        startpull = {'/rg dopull 1'},
                        starthunt = {'/bcg //rg chaseon <toon name>','/rg dopull 2'}
                    }
    salt.save(runmission.toon, SETTINGS_PATH)
end
if runmission.toon.starthunt==nil then 
    runmission.toon.starthunt={'/rg dopull 2'} 
    salt.save(runmission.toon, SETTINGS_PATH)
end
local dostart = false
local miss_select = 1
local chosenmission = 'none'
local missionlist = {'none','Shei Vinitras','Restless Assault'}


if arg ~= '' then
    for i,v in pairs(missionlist) do
        if string.find(v,arg) then
            chosenmission = v
            miss_select = tonumber(i)
            dostart = true
        end
    end
end


local function configuremission(name)
    if name=='none' then 
        runmission.mission = nil
        runmission.running = false
    end
    if name=='Shei Vinitras' then
        runmission.startzone   = "maidentwo"
        runmission.missionzone = 'mission' --looks for misson in the shortname of the zone
        runmission.mission     = 'Shei Vinitras'
        runmission.questgiver  = 'a worrisome shade'
        runmission.startword   = 'small'
        runmission.enterword   = 'ready'
        runmission.campspotyxz = '264 -950 -19' --desired campspot (not used atm)
        runmission.mobcount    = 0
        runmission.huntmode     = false
        runmission.currentmessage = runmission.mission
        runmission.getmission   = {'/navgroupto a worrisome shade', 'delay 2000','/say small','delay 60000'}
        --runmission.entermission = {'/navgroupto a worrisome shade'} -- not used atm
        runmission.initcommand  = {'delay 15000','doubleinvis','delay 15000','/bcga //clean','/bcga //nav locyxz 264 -950 -19','delay 20000','startstuff'}
        runmission.stopcommand  = {'/kickp task','delay 5000','/yes','delay 35000','stopstuff','delay 120000'}
        runmission.running      = false
    end
    if name=='Restless Assault' then
        runmission.startzone   = "greatdividetwo"
        runmission.missionzone = 'mission' --looks for misson in the shortname of the zone
        runmission.mission     = 'Restless Assault'
        runmission.questgiver  = 'Zrelik the Brave'
        runmission.startword   = 'small'
        runmission.enterword   = 'ready'
        runmission.campspotyxz = '-2110 -428 -319' --desired campspot (not used atm)
        runmission.mobcount    = 172
        runmission.huntmode     = true
        runmission.currentmessage = runmission.mission
        runmission.getmission   = {'/navgroupto Zrelik the Brave','/dgz /makemevis', 'delay 2000','/say small','delay 60000'}
        --runmission.entermission = {'/navgroupto Zrelik the Brave'} -- not used atm
        runmission.initcommand  = {'delay 15000','/bcga //dismount','doubleinvis','delay 15000','/bcga //clean','/bcga //nav locyxz -2110 -428 -319','delay 20000','startstuff'}
        runmission.stopcommand  = {'/kickp task','delay 5000','/yes','delay 35000','stopstuff','delay 120000'}
        runmission.running      = false
    end
end

local function editsetting(title,setting)
    if ImGui.TreeNode(title) then
        for i, v in ipairs(setting) do
            imgui.Text(i)
            imgui.SameLine()
            setting[i]=imgui.InputText('##'..title..i,v)
            if i==#setting then
                imgui.SameLine()
                if imgui.SmallButton('add##'..title..i) then
                    table.insert(setting,'')
                end    
            end            
            if i==#setting and i>1 then
                imgui.SameLine()
                if imgui.SmallButton('Del##'..title..'del'..i) then
                    setting[i]=nil
                end
            end
        end
        ImGui.TreePop()
    end
end

local function HelpMarker(desc)
    imgui.TextDisabled('(?)')
    if imgui.IsItemHovered() then
        imgui.BeginTooltip()
        imgui.PushTextWrapPos(imgui.GetFontSize() * 35.0)
        imgui.Text(desc)
        imgui.PopTextWrapPos()
        imgui.EndTooltip()
    end
end

local PrepGUI = function()
    local flags = ImGuiWindowFlags.AlwaysAutoResize or 0
    openGUI, shouldDrawGUI = imgui.Begin('Mission Repeater', openGUI, flags)
    if shouldDrawGUI then
        imgui.BeginTabBar('prep', ImGuiTabBarFlags.Reorderable)
        if imgui.BeginTabItem('Overview') then
            local mflags = ImGuiComboFlags.PopupAlignLeft
            imgui.Text('Mission:')
            imgui.SameLine()
            imgui.TextColored(0,0.88,0,1,tostring(runmission.mission))
            imgui.SameLine()
            if mq.TLO.Task(runmission.mission).Timer()~=nil then
                imgui.Text('Time left: ')
                imgui.SameLine()
                imgui.TextColored(0,0.88,0,1,mq.TLO.Task(runmission.mission).Timer.TimeHMS())
            end
            imgui.Separator()
            if runmission.currentmessage~=nil then imgui.Text(runmission.currentmessage) end            
            imgui.EndTabItem()            
        end
        if imgui.BeginTabItem('Mission') then
            imgui.Text('Pick a mission:') imgui.SameLine()
            if imgui.BeginCombo("##missions",chosenmission, mflags) then      
                for i, v in pairs(missionlist) do     
                    local mission_select = miss_select == i            
                    if imgui.Selectable(v, mission_select) then
                        miss_select = mission_select
                        chosenmission = v
                        print(chosenmission)
                        configuremission(chosenmission)
                    end
                end        
                imgui.EndCombo()
            end
            if runmission.running == false and chosenmission~='none' then
                if imgui.SmallButton('Begin mission') then
                    runmission.running=true
                end
            elseif runmission.running == true and chosenmission~='none' then
                if imgui.SmallButton('End mission') then
                    runmission.endmission=true
                    runmission.running=false
                    runmission.breakdelay=truex
                end
            end
            if mq.TLO.Zone.ShortName()~=runmission.startzone and runmission.entered==false then
                if imgui.SmallButton('Move group to mission zone using /travelto') then
                    mq.cmd('/bcga //travelto '..runmission.startzone)
                end
            end
            imgui.EndTabItem()
        end
        if imgui.BeginTabItem('Settings') then
                if imgui.SmallButton('Save Settings') then
                    salt.save(runmission.toon, SETTINGS_PATH)
                end
                imgui.Separator()
                editsetting('Group/Toon Startup',runmission.toon.startstuff)
                editsetting('Toon Startpull',runmission.toon.startpull)
                editsetting('Toon Starthunt',runmission.toon.starthunt)
                editsetting('Toon Stop',runmission.toon.stopstuff)
                editsetting('Group Stoppull',runmission.toon.stoppull)
                editsetting('Group Invis',runmission.toon.inviscommand)
            imgui.EndTabItem()
        end
        imgui.EndTabBar()
    end
    imgui.End()
end

mq.imgui.init('PrepGUI', PrepGUI)

print('starting support lua on group members, tml.lua (will log after around 30 minutes of sitting in guildlobby)')
mq.cmd('/bcga //lua run prep/tml.lua')

local outtimer = 48000

configuremission('none')

if dostart==true then 
    configuremission(chosenmission)
    runmission.running=true 
    dostart=false
end

if runmission.initcommand ~= nil then
    while openGUI do
        if runmission.mission~=nil and runmission.running==true then
            mq.delay(1000)
            runmission.repeatmission() 
        end
        mq.delay(100)
        if mq.TLO.Me.XTarget()>0 and mq.TLO.Me.XTarget(1).TargetType=='Auto Hater' then
            outtimer = 4800
        end
    end
else
    print('no mission to run in this zone, ending')
end
